/*
** BeNES - Nintendo Entertaiment System Emulator for BeOS
**
** * 1999 by makoto yamagata
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// Std type definition
//
#ifndef NESTYPES_H_DEFINED
#define NESTYPES_H_DEFINED

#include <stdio.h>

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;

const int PPU_MIRROR_VERTICAL = 0;
const int PPU_MIRROR_HORIZONTAL = 1;
const int PPU_MIRROR_ONELOW = 2;
const int PPU_MIRROR_ONEHIGH = 3;

const int NES_TRAINER_SIZE = 0x200;
const int NES_PRGBANK_SIZE = 0x4000;
const int NES_CHRBANK_SIZE = 0x2000;
const int NES_SAVERAM_SIZE = 0x2000;

struct NesVirtualScreen {
	enum { Width=256, Height=240 };
	uchar bits[Height][Width];
};

#endif
