#ifndef NESSOUND_H_DEFINED
#define NESSOUND_H_DEFINED

#include <stdio.h>
#include "audio.h"

//======================================================================
struct NesSoundVoice {
	HAC mVoice;
	LPAUDIOWAVE mWave;
public:
	NesSoundVoice():
		mWave(NULL){ ; }
};

struct NesSoundSource {
	NesSoundVoice* mSound;
	NesSoundVoice* mChanged;
	unsigned short mFreq;
	long mVolume;
	long mFreqValue;
	bool mPlaying;
public:
	NesSoundSource():
		mSound(NULL), mChanged(NULL), 
		mFreq(0L), mVolume(0L), mPlaying(false) { ; }

};

//======================================================================
class NesSound {
	enum { NUMSOUNDS=10, NUMCHANNELS=4 };
	NesSoundVoice mSq0Sound[4];
	NesSoundVoice mSq1Sound[4];
	NesSoundVoice mTriSound;
	NesSoundVoice mNizSound;
	NesSoundSource mChannel[NUMCHANNELS];
	unsigned char mEnabled;
public:
	NesSound();
	~NesSound();
	void enableChannel(unsigned char enabled);
	void setFreq(int channel, unsigned short val);
	void setNoiseFreq(unsigned short val);
	void setVolume(int channel, long val);
	void stop(int channel);
	void play(int channel);
	void update(int channel);
	long getVolume(int channel) { 
		return mChannel[channel].mVolume;
	}
	unsigned short getFreq(int channel) { 
		return mChannel[channel].mFreq;
	}
	void setSq0Wave(unsigned char type);
	void setSq1Wave(unsigned char type);
};

#endif
